import{isEmpty,humanSize,truncate,cleanHTML}from"../../base/helpers.mjs";import{MenuController}from"../menu.mjs";import{ElementBuilder}from"../../base/builder.mjs";import{View,ParentView,TabbedView}from"../../view/base.mjs";import{SimpleNotification}from"../../common/notify.mjs";import{CivitAISearchOptionsFormView}from"../../forms/enfugue/civitai.mjs";const E=new ElementBuilder,browserWindowDimensions=[800,1e3];class CivitAIItemView extends View{static className="civit-ai-item";static maxImagesPerItem=3;static maxCharactersPerDescription=300;static maxTags=6;constructor(t,e,i){super(t),this.item=e,this.download=i}async build(){let t=await super.build(),e=this.item.modelVersions[0].name,i=E.h2().content(E.a().content(this.item.name).target("_blank").href(`https://civitai.com/models/${this.item.id}`)),s=E.h4().content(E.span().content("By "),E.a().content(`${this.item.creator.username}`).target("_blank").href(`https://civitai.com/user/${this.item.creator.username}`)),o=E.select(),a=E.div().class("versions"),n=E.div().class("flags"),r=E.div().class("tags"),l=E.p(),c=()=>{let t=this.item.modelVersions.filter((t=>e.startsWith(t.name))).shift(),i=t.trainedWords,s=t.images.slice(0,this.constructor.maxImagesPerItem),o=s.map((t=>{let e;return e="video"===t.type?E.video().content(E.source().src(t.url)).autoplay(!0).muted(!0).loop(!0).controls(!1):E.img().src(t.url),e.css({"max-width":`${(1/s.length*100).toFixed(2)}%`}),isEmpty(t.meta)||isEmpty(t.meta.prompt)||e.data("tooltip",cleanHTML(t.meta.prompt)),e})),n=i.map((t=>E.span().content(t))),r=t.files.map((t=>E.div().class("download").content(E.span().class("name").content(t.name),E.span().class("type").content(`${t.metadata.size||""} ${t.metadata.fp||""}`),E.span().class("format").content(t.metadata.format),E.span().class("size").content(humanSize(1e3*t.sizeKB)),E.a().href(t.downloadUrl).content(E.i().class("fa-solid fa-download")).data("tooltip","Start Download").on("click",(e=>{e.preventDefault(),e.stopPropagation(),this.download(t.downloadUrl,t.name)})))));a.content(E.div().class("downloads").content(...r),E.div().class("images").content(...o),E.div().class("triggers").content(...n))};if(!isEmpty(this.item.description))if(this.item.description.length<=this.constructor.maxCharactersPerDescription)l.content(this.item.description);else{let t=E.span().content(truncate(this.item.description,this.constructor.maxCharactersPerDescription)),e=E.span().content(this.item.description).hide(),i=E.a().content("Show All").on("click",(()=>{t.hide(),i.hide(),e.show()}));l.content(t,i,e)}for(let t of this.item.tags.slice(0,this.constructor.maxTags))r.append(E.span().content(t));"None"===this.item.allowCommercialUse?n.append(E.span().content("Commercial Use Disallowed")):"Image"===this.item.allowCommercialUse?n.append(E.span().content("Commercial Use Allowed (Images Only)")):"Rent"===this.item.allowCommercialUse||"Sell"===this.item.allowCommercialUse||"RentCivit"===this.item.allowCommercialUse?n.append(E.span().content("Commercial Use Allowed")):console.warn(`Unknown commercial use state '${this.item.allowCommercialUse}' for ${this.item.name}`),this.item.allowNoCredit?n.append(E.span().content("No Credit Required")):n.append(E.span().content("Credit Required")),this.item.allowDerivatives?n.append(E.span().content("Derivative Models Allowed")):n.append(E.span().content("Derivative Models Disallowed"));for(let t of this.item.modelVersions){let i=E.option().content(`${t.name} (${t.baseModel})`);t.name===e&&i.selected(!0),o.append(i)}return o.on("change",(t=>{e=o.val(),c()})),o.val(e),c(),t.append(i).append(s).append(n).append(r).append(l).append(o).append(a),t}}class CivitAICategoryPageView extends View{static className="page-buttons";constructor(t,e,i){super(t),this.showPrevious=e,this.showNext=i,this.onPreviousCallbacks=[],this.onNextCallbacks=[]}onNext(t){this.onNextCallbacks.push(t)}onPrevious(t){this.onPreviousCallbacks.push(t)}previousPage(){for(let t of this.onPreviousCallbacks)t()}nextPage(){for(let t of this.onNextCallbacks)t()}async build(){let t=await super.build(),e=E.button().content("Previous Page").on("click",(()=>this.previousPage())),i=E.button().content("Next Page").on("click",(()=>this.nextPage()));return this.showPrevious||e.disabled(!0),this.showNext||i.disabled(!0),t.content(e,i)}}class CivitAICategoryBrowserView extends ParentView{static inputTimeout=500;static pageSize=20;constructor(t,e,i){super(t),this.getData=e,this.download=i,this.page=1,this.query="",this.timer=null,this.options=new CivitAISearchOptionsFormView(t),this.options.onSubmit((async t=>{try{this.page=1,await this.runQuery(t)}catch(t){SimpleNotification.notify("Couldn't communicate with Enfugue or CivitAI. Please try again."),console.error(t)}this.options.enable()})),this.empty(),this.addChild(this.options)}async runQuery(t){this.empty(),this.addChild(this.options);let e={page:this.page};isEmpty(t.search)||(e.query=t.search),isEmpty(t.sort)||(e.sort=t.sort),isEmpty(t.period)||(e.period=t.period),!0===t.commercial&&(e.allow_commercial_use="Image"),!0===t.nsfw&&(e.nsfw=!0);for(let t of await this.getData(null,e)){let e=new CivitAIItemView(this.config,t,((...t)=>this.download(...t)));await this.addChild(e)}let i=new CivitAICategoryPageView(this.config,this.page>1,this.children.length>this.constructor.pageSize);i.onNext((async()=>{this.page++,this.options.disable(),await this.runQuery(t),this.options.enable()})),i.onPrevious((async()=>{this.page--,this.options.disable(),await this.runQuery(t),this.options.enable()})),await this.addChild(i)}async build(){let t=await super.build();return this.options.submit(),t}}class CivitAIBrowserView extends TabbedView{constructor(t,e,i){super(t),this.addTab("Checkpoints",new CivitAICategoryBrowserView(t,((...t)=>e("checkpoint",...t)),((...t)=>i("checkpoint",...t)))),this.addTab("LoRA",new CivitAICategoryBrowserView(t,((...t)=>e("lora",...t)),((...t)=>i("lora",...t)))),this.addTab("LyCORIS",new CivitAICategoryBrowserView(t,((...t)=>e("lycoris",...t)),((...t)=>i("lycoris",...t)))),this.addTab("Textual Inversion",new CivitAICategoryBrowserView(t,((...t)=>e("inversion",...t)),((...t)=>i("inversion",...t)))),this.addTab("Motion Modules",new CivitAICategoryBrowserView(t,((...t)=>e("motion",...t)),((...t)=>i("motion",...t))))}}class CivitAIView extends View{static logoPath="/static/img/brand/civit-ai-logo.svg";static className="civit-ai-view";constructor(t,e,i){super(t),this.browser=new CivitAIBrowserView(t,e,i)}getDescriptionNode(){return E.div().content(E.a().href("https://civitai.com").target("_blank").content(E.img().src(this.constructor.logoPath)),E.p().content("CivitAI is the leading AI model sharing service, providing a place where creators can uploads their trained models for other users to enjoy and employ."),E.p().content(E.span().content("By downloading any models from CivitAI, you agree to their "),E.a().href("https://civitai.com/content/tos").target("_blank").content("terms of service"),E.span().content(". Please review these terms before downloading anything. Some models come with additional terms, such as disallowing sale of images derived from those models. Use the filters at the top to only search for your desired terms, or pay attention to the tags below the model's name and author.")),E.p().content(E.span().content("If you enjoy the service CivitAI provides, please consider "),E.a().href("https://civitai.com/pricing").target("_blank").content("subscribing or donating"),E.span().content(" to support free and open-source AI.")),E.p().class("center").content(E.em().class("note").content("CivitAI, the CivitAI logo, and the CivitAI 'C' icon are all &copy; CivitAI "+(new Date).getFullYear()+", all rights reserved.")))}async build(){let t=await super.build();return t.append(this.getDescriptionNode()),t.append(await this.browser.getNode()),t}}class CivitAIController extends MenuController{static menuName="Civit AI";static menuIcon="/static/img/brand/civit-ai.png";static menuShortcut="a";async showBrowser(){let t=(t,...e)=>this.model.get(`civitai/${t}`,...e),e=(t,e,i)=>this.download(t,e,i);isEmpty(this.browser)?(this.browser=await this.spawnWindow("CivitAI",new CivitAIView(this.config,t,e),...browserWindowDimensions),this.browser.onClose((()=>this.browser=null))):this.browser.focus()}async onClick(){this.showBrowser()}}export{CivitAIController as MenuController};
