import{API,JSONAPI}from"../base/api.mjs";import{getCookie,isEmpty,kebabCase,deepClone}from"../base/helpers.mjs";let checkParseValue=t=>/^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}(.\d+)?$/.test(t)?new Date(t):t;class ModelAPI extends JSONAPI{async multiPart(t,e,s,i,r,a){let o=new FormData;for(let t in i)o.append(t,i[t]);let h=this.timeout;this.timeout=null;let l=await API.prototype.query.apply(this,["POST",t,e,s,o,r,a]);return this.timeout=h,l}}class ModelObject{static alwaysInclude=!1;constructor(t,e,s,i){this._model=t,this._attributes={};for(let t in e){let s=e[t];this._attributes[t]=checkParseValue(s)}this._relationships=s,this._seeAlso=i,this._changes={},this._dirty=!1,this._deleted=!1;for(let t in e)Object.defineProperty(this,t,{get:()=>isEmpty(this._changes[t])?this._attributes[t]:this._changes[t],set:e=>{if(this._deleted)throw"Object is deleted, cannot modify.";this._changes[t]=e,this._dirty=!0}});if(!isEmpty(s))for(let t in s)Object.defineProperty(this,t,{get:()=>this._relationships[t]})}get see(){return this._seeAlso}getAttributes(){return this._attributes}queryModel(t,e,s,i,r,a,o){return this._model.query(t,e,s,i,r,a,o)}static hasFullScope(t){let e=this.apiScope;if(!isEmpty(this.apiScope))for(let s of e)if(isEmpty(t[s]))return!1;return!0}static getMethods(){return Object.getOwnPropertyNames(this).filter((t=>"function"==typeof this[t]))}static getURL(t){let e=this.apiRoot,s=this.apiScope,i=this.apiInclude,r=isEmpty(t)?{}:deepClone(t),a=isEmpty(s);isEmpty(e)&&(e=kebabCase(this.name));let o=`${e}/`,h={};if(!isEmpty(s)&&!isEmpty(r))for(let t of s){if(isEmpty(r[t])){a=!1;break}o+=`${r[t]}/`,delete r[t],a=!0}return isEmpty(r)||(h.filter=Object.getOwnPropertyNames(r).map((t=>`${t}:${r[t]}`))),!a&&!this.alwaysInclude||isEmpty(i)||(h.include=i),[o.substring(0,o.length-1),h]}get url(){return this.constructor.getURL(this._attributes)[0]}stageChanges(t){for(let e in t)this.stageChange(e,t[e])}stageChange(t,e){if(this._deleted)throw"Object is deleted, cannot modify.";this._changes[t]=e,this._dirty=!0}async save(){if(this._deleted)throw"Object is deleted.";if(!this._dirty)return;await this.queryModel("patch",this.url,{},{},this._changes);for(let t in this._changes)this._attributes[t]=this._changes[t];this._changes={},this._dirty=!1}async requery(t){let[e,s]=this.constructor.getURL(this._attributes);delete s.filter,isEmpty(t)||(s={...t,...s});let i=await this._model.get(e,{},s);return this.constructor.mapModelResult(this._model,i)}async delete(){if(this.deleted)throw"Object is deleted.";let[t]=this.constructor.getURL(this._attributes);await this._model.delete(t),this._deleted=!0}static async create(t,e,s){isEmpty(this.apiName)?this.name:this.apiName;let[i]=this.getURL(),r=!0===this.multiPart?t.multiPart:t.post,a=await r.call(t,i,{},{},e,s);return this.mapModelResult(t,a)}static async query(t,e,s,i){isEmpty(this.apiName)?this.name:this.apiName;let[r,a]=this.getURL(e);a={...a,...isEmpty(s)?{}:s};let o,h,l,n=await t.get(r,{},a,null,null,i);return i?[o,h]=n:o=n,l=this.mapModelResult(t,o),i?[l,h]:l}static mapModelResult(t,e){let s=isEmpty(this.apiName)?this.name:this.apiName,i=e=>{let r;if(r=e.type===s?this:t.constructor.modelObjects.filter((t=>(isEmpty(t.apiName)?t.name:t.apiName)===e.type)).shift(),isEmpty(r))throw"Cannot map type "+e.type;let a=e.attributes,o=e.include,h=e.see;return isEmpty(o)||(o=Object.getOwnPropertyNames(o).reduce(((t,e)=>{let s=o[e];return Array.isArray(s)&&s.length>0?t[e]=s.map(i):isEmpty(s)||(t[e]=i(s)),t}),{})),isEmpty(h)||(h=h.map((t=>i(t)))),new r(t,a,o,h)};return isEmpty(e)?null:Array.isArray(e)?e.length>1?e.map(i):i(e[0]):i(e)}}class ModelBoundObject{constructor(t,e){this._model=t,this._modelObject=e;for(let s of["query","create"].concat(e.getMethods()))this[s]=function(){return e[s].apply(e,[t].concat(Array.from(arguments)))}}async queryAll(t){let e=await this.query(t,0);return isEmpty(e)?e=[]:Array.isArray(e)||(e=[e]),e}}class Model{static modelObjects=[];static debounceMethods=["get","head","options"];constructor(t){let e=t.url.api;e.startsWith("http")||(e=t.url.root,e.endsWith("/")?t.url.api.startswith("/")&&(e=e.substring(0,e.length-1)):t.url.api.startswith("/")||(e+="/"),e+=t.url.api),this.api=new ModelAPI(e,t.debug),this.key=isEmpty(t.keys)?null:t.keys.api,this.token=getCookie(t.model.cookie.name),this.debounce={};for(let t of API.allMethods)this[t]=(e,s,i,r,a,o)=>this.query(t.toUpperCase(),e,s,i,r,a,o),-1!==this.constructor.debounceMethods.indexOf(t)&&(this.debounce[t]={});for(let t of this.constructor.modelObjects)this[t.name]=new ModelBoundObject(this,t)}async download(t,e,s,i,r,a){return(s=s||{}).Authorization="Bearer "+this.token,isEmpty(this.key)||(s["X-API-Key"]=this.key),await this.api.download(t,e,s,i,r,a)}query(t,e,s,i,r,a,o){t=t.toLowerCase();let h,l=-1!==this.constructor.debounceMethods.indexOf(t);if(l&&(h=this.api.buildUrl(e,i),void 0!==this.debounce[t][h]))return console.warn(`Debouncing ${t.toUpperCase()} ${h}`),this.debounce[t][h];(s=s||{}).Authorization="Bearer "+this.token,isEmpty(this.key)||(s["X-API-Key"]=this.key);let n=new Promise((async(n,c)=>{try{let h=await this.api.query(t,e,s,i,r,a);n(o?[h.data,h.meta]:h.data)}catch(a){try{c(a.errors[0])}catch(o){console.error("Error in API request",t,e,s,i,r),c(a)}}finally{l&&delete this.debounce[t][h]}}));return l&&(this.debounce[t][h]=n),n}rawQuery(t,e,s,i,r,a){return(s=s||{}).Authorization="Bearer "+this.token,isEmpty(this.key)||(s["X-API-Key"]=this.key),this.api.rawQuery(t,e,s,i,r,a)}async multiPart(t,e,s,i,r){(e=e||{}).Authorization="Bearer "+this.token,isEmpty(this.key)||(e["X-API-Key"]=this.key);try{let a=await this.api.multiPart(t,e,s,i,r);return JSON.parse(a).data}catch(t){try{throw JSON.parse(t.responseText).errors[0].detail}catch(e){throw t}}}}export{Model,ModelObject};
